﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.ComponentModel.Composition;
using Caliburn.Micro;
using VisualComponents.Create3D;
using VisualComponents.UX.Shared;


namespace Example005
{
    [Export(typeof(IPlugin))]
    public class MyPlugin : IPlugin
    {
        private IApplication app;
        List<IMaterial> originalComponentMaterials;

        [ImportingConstructor]
        public MyPlugin([Import(typeof(IApplication))] IApplication app)
        {
            this.app = app;
            this.app.Simulation.SimulationStopped += HighlightDynamicComponents;
            this.app.Simulation.SimulationStarted += ClearHighlightDynamicComponents;
        }

        private void ClearHighlightDynamicComponents(object sender, EventArgs e)
        {
            List<ISimComponent> components;
            //components.AddRange(app.World.Components.Where(c => c.IsDynamic == true));
            components = app.World.Components.Where(c => c.IsDynamic == true).ToList();

            if (originalComponentMaterials != null)
            {
                for (int i = 0; i < components.Count; i++)
                {
                    components[i].Material = originalComponentMaterials[i];
                }
            }
        }

        private void HighlightDynamicComponents(object sender, EventArgs e)
        {
            //originalComponentMaterials.Clear();
            //originalComponentMaterials.AddRange(app.World.Components.Where(component => component.IsDynamic == true).Select(component => component.Material));
            originalComponentMaterials = app.World.Components.Where(c => c.IsDynamic == true).Select(c => c.Material).ToList();

            IMaterial mat = app.FindMaterial("red", false);
            foreach (ISimComponent comp in app.World.Components)
            {
                if (comp.IsDynamic == true)
                {
                    //originalComponentMaterials.Add(comp.Material);
                    comp.Material = mat;
                }
            }
        }

        void IPlugin.Exit()
        {
        }

        void IPlugin.Initialize()
        {
        }
    }
}
